commit 7d9678db98f665be3874b8a71510eb9dfa7c1e9f
Author: skenneweg <skenneweg@techfak.uni-bielefeld.de>
Date:   Mon May 4 15:32:52 2020 +0200

    Finished header, added empty functions in c classes, added comments

diff --git a/src/urt_subscriber.c b/src/urt_subscriber.c
index c2992d9..3d38acb 100644
--- a/src/urt_subscriber.c
+++ b/src/urt_subscriber.c
@@ -19,6 +19,8 @@ You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
+#include <urtware.h>
+
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
@@ -42,26 +44,257 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /******************************************************************************/
 /* EXPORTED FUNCTIONS                                                         */
 /******************************************************************************/
-#include "subscriber.h"
 
-void urtNrtSubscriberInit (urt_nrtsubscriber_t* subscriber) {}
+/**
+ * @brief   Initialize the nrt Subscriber.
+ *
+ * @param[in] subscriber  Subscriber to initalize.
+ */
+void urtNrtSubscriberInit (urt_nrtsubscriber_t* subscriber) {return;}
 
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber  Subscriber to  .
+ * @param[in] topic   .
+ * @param[in] messages   .
+ *
+ * @return  A status value.
+ */
 urt_status_t urtNrtSubscriberSubscribe (urt_nrtsubscriber_t* subscriber, urt_topic_t* topic, urt_message_t* messages) {
-  return 1;
+  return URT_STATUS_OK;
 }
 
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber   .
+ * @param[in] payload   .
+ * @param[in] bytes   .
+ * @param[in] latency   .
+ *
+ * @return  A status value.
+ */
 urt_status_t urtNrtSubscriberFetchNextMessage (urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency) {
-  return 0;
+  return URT_STATUS_OK;
 }
 
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber   .
+ * @param[in] payload   .
+ * @param[in] bytes   .
+ * @param[in] latency   .
+ *
+ * @return  A status value.
+ */
 urt_status_t urtNrtSubscriberFetchLatestMessage (urt_nrtsubscriber_t* subscriber, void* payload, size_t bytes, urt_delay_t* latency) {
-  return 0;
+  return URT_STATUS_OK;
 }
 
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber
+ *
+ * @return  A status value.
+ */
 urt_status_t urtNrtSubscriberUnsubscribe (urt_nrtsubscriber_t* subscriber) {
-  return 0;
+  return URT_STATUS_OK;
 }
 
-int main () {
- return 0;
-}
+
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber  .
+ */
+void urtSrtSubscriberInit(urt_srtsubscriber_t* subscriber) {return;}
+
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber  .
+ * @param[in] topic  .
+ * @param[in] message  .
+ * @param[in] usefulnesscb  .
+ * @param[in] cbparams  .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtSrtSubscriberSubscribe(urt_srtsubscriber_t* subscriber, urt_topic_t* topic,
+                                       urt_message_t* message, urt_srtusefulnessfunc_t* usefulnesscb, void* cbparams) {return URT_STATUS_OK;}
+
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber  .
+ * @param[in] payload  .
+ * @param[in] latency  .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtSrtSubscriberFetchNextMessage(urt_srtsubscriber_t* subscriber, void* payload,
+                                              size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+/**
+ * @brief    .
+ *
+ * @param[in] subscriber  .
+ * @param[in] payload  .
+ * @param[in] bytes  .
+ * @param[in] latency  .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtSrtSubscriberFetchLatestMessage(urt_srtsubscriber_t* subscriber, void* payload,
+                                                size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtSrtSubscriberCalculateUsefulness(urt_srtsubscriber_t* subscriber, urt_delay_t latency){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtSrtSubscriberUnsubscribe(urt_srtsubscriber_t* subscriber){return URT_STATUS_OK;}
+
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ *
+ * @return  A status value.
+ */
+void urtFrtSubscriberInit(urt_frtsubscriber_t* subscriber){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] topic .
+ * @param[in] messages .
+ * @param[in] deadline .
+ * @param[in] jitter .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtFrtSubscriberSubscribe(urt_frtsubscriber_t* subscriber, urt_topic_t* topic,
+                                       urt_message_t* messages, urt_delay_t deadline, urt_delay_t jitter){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] payload .
+ * @param[in] bytes .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtFrtSubscriberFetchNextMessage(urt_frtsubscriber_t* subscriber, void* payload,
+                                              size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] payload .
+ * @param[in] bytes .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtFrtSubscriberFetchLatestMessage(urt_frtsubscriber_t* subscriber, void* payload,
+                                                size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+bool urtFrtSubscriberCalculateValidity(urt_frtsubscriber_t* subscriber, urt_delay_t latency){return true;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtFrtSubscriberUnsubscribe(urt_frtsubscriber_t* subscriber){return URT_STATUS_OK;}
+
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ */
+void urtHrtSubscriberInit(urt_hrtsubscriber_t* subscriber){return;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] topic .
+ * @param[in] message .
+ * @param[in] deadline .
+ * @param[in] rate .
+ * @param[in] jitter .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtHrtSubscriberSubscribe(urt_hrtsubscriber_t* subscriber, urt_topic_t* topic,
+                                       urt_message_t* message, urt_delay_t deadline, urt_delay_t rate, urt_delay_t jitter){return URT_STATUS_OK;}
+
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] payload .
+ * @param[in] bytes .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtHrtSubscriberFetchNextMessage(urt_hrtsubscriber_t* subscriber, void* payload,
+                                              size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ * @param[in] payload .
+ * @param[in] bytes .
+ * @param[in] latency .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtHrtSubscriberFetchLatestMessage(urt_hrtsubscriber_t* subscriber, void* payload,
+                                                size_t bytes, urt_delay_t* latency){return URT_STATUS_OK;}
+
+/**
+ * @brief   .
+ *
+ * @param[in] subscriber .
+ *
+ * @return  A status value.
+ */
+urt_status_t urtHrtSubscriberUnsubscribe(urt_hrtsubscriber_t* subscriber){return URT_STATUS_OK;}