commit 11500ad81cfe6291b84e2faaf5731446da4014d4
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Oct 19 17:08:24 2018 +0200

    Defined all apalControGpio_t driver members to be const since they must be changed.

diff --git a/include/alld_a3906.h b/include/alld_a3906.h
index f816a1d..e485238 100644
--- a/include/alld_a3906.h
+++ b/include/alld_a3906.h
@@ -40,7 +40,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief A3906 driver struct.
  */
 typedef struct {
-  apalControlGpio_t* power_pin;   /**< @brief GPIO to enable/disable power of the A3906. */
+  const apalControlGpio_t* power_pin;   /**< @brief GPIO to enable/disable power of the A3906. */
 } A3906Driver;
 
 /**
diff --git a/include/alld_bq24103a.h b/include/alld_bq24103a.h
index 3ec5ce5..ea37706 100644
--- a/include/alld_bq24103a.h
+++ b/include/alld_bq24103a.h
@@ -45,8 +45,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief The BQ24103A driver struct.
  */
 typedef struct {
-  apalControlGpio_t* gpio_enabled;        /**< @brief GPIO to enable/disable the bq24103a */
-  apalControlGpio_t* gpio_charge_status;  /**< @brief GPIO showing the status of the bq24103a */
+  const apalControlGpio_t* gpio_enabled;        /**< @brief GPIO to enable/disable the bq24103a */
+  const apalControlGpio_t* gpio_charge_status;  /**< @brief GPIO showing the status of the bq24103a */
 } BQ24103ADriver;
 
 /**
diff --git a/include/alld_bq27500.h b/include/alld_bq27500.h
index 0539c6c..63d7f96 100644
--- a/include/alld_bq27500.h
+++ b/include/alld_bq27500.h
@@ -209,8 +209,8 @@ typedef union {
  */
 typedef struct {
   apalI2CDriver_t* i2cd;            /**< @brief I2C driver to access the BQ27500 */
-  apalControlGpio_t* gpio_batlow;   /**< @brief Gpio to indicate whether the battery is low  */
-  apalControlGpio_t* gpio_batgood;  /**< @brief Gpio to indicate whether the battery is good */
+  const apalControlGpio_t* gpio_batlow;   /**< @brief Gpio to indicate whether the battery is low  */
+  const apalControlGpio_t* gpio_batgood;  /**< @brief Gpio to indicate whether the battery is good */
 } BQ27500Driver;
 
 /**
diff --git a/include/alld_led.h b/include/alld_led.h
index 3f41fda..0df833b 100644
--- a/include/alld_led.h
+++ b/include/alld_led.h
@@ -40,7 +40,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief LED driver data structure.
  */
 typedef struct {
-  apalControlGpio_t* gpio;  /**< @brief The identifier of the GPIO.  */
+  const apalControlGpio_t* gpio;  /**< @brief The identifier of the GPIO.  */
 } LEDDriver;
 
 /**
diff --git a/include/alld_ltc4412.h b/include/alld_ltc4412.h
index b17f98b..36cdb5c 100644
--- a/include/alld_ltc4412.h
+++ b/include/alld_ltc4412.h
@@ -45,8 +45,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief LTC4412 driver struct.
  */
 typedef struct {
-  apalControlGpio_t* gpio_ctrl;   /**< @brief Control GPIO */
-  apalControlGpio_t* gpio_stat;   /**< @brief Status GPIO */
+  const apalControlGpio_t* gpio_ctrl;   /**< @brief Control GPIO */
+  const apalControlGpio_t* gpio_stat;   /**< @brief Status GPIO */
 } LTC4412Driver;
 
 typedef enum {
diff --git a/include/alld_tlc5947.h b/include/alld_tlc5947.h
index b0f1ec2..683786f 100644
--- a/include/alld_tlc5947.h
+++ b/include/alld_tlc5947.h
@@ -61,8 +61,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 typedef struct {
   apalSPIDriver_t* spi_driver;    /**< @brief The SPI Driver.                           */
-  apalControlGpio_t* blank_gpio;  /**< @brief The identifier of the BLANK signal GPIO.  */
-  apalControlGpio_t* xlat_gpio;   /**< @brief The identifier of the XLAT signal GPIO.   */
+  const apalControlGpio_t* blank_gpio;  /**< @brief The identifier of the BLANK signal GPIO.  */
+  const apalControlGpio_t* xlat_gpio;   /**< @brief The identifier of the XLAT signal GPIO.   */
 } TLC5947Driver;
 
 /**
diff --git a/include/alld_tps2051bdbv.h b/include/alld_tps2051bdbv.h
index 477adcb..bf44ff3 100644
--- a/include/alld_tps2051bdbv.h
+++ b/include/alld_tps2051bdbv.h
@@ -45,8 +45,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief The TPS2051B driver struct.
  */
 typedef struct {
-  apalControlGpio_t* enable;        /**< @brief GPIO to enable/disable the tps2051b. */
-  apalControlGpio_t* overcurrent;   /**< @brief GPIO to indicate overcurrent */
+  const apalControlGpio_t* enable;        /**< @brief GPIO to enable/disable the tps2051b. */
+  const apalControlGpio_t* overcurrent;   /**< @brief GPIO to indicate overcurrent */
 } TPS2051BDriver;
 
 /**
diff --git a/include/alld_tps62113.h b/include/alld_tps62113.h
index 9b19859..d29ce29 100644
--- a/include/alld_tps62113.h
+++ b/include/alld_tps62113.h
@@ -40,7 +40,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief The TPS62113 driver struct.
  */
 typedef struct {
-  apalControlGpio_t* gpio_power;  /**< GPIO to turn power on/off */
+  const apalControlGpio_t* gpio_power;  /**< GPIO to turn power on/off */
 } TPS62113Driver;
 
 /**